%global __brp_check_rpaths %{nil}
%global __requires_exclude ^libmpi
%global packname  rMIDAS
%global packver   1.0.0
%global rlibdir   /usr/local/lib/R/library

Name:             R-CRAN-%{packname}
Version:          1.0.0
Release:          1%{?dist}%{?buildtag}
Summary:          Multiple Imputation with Denoising Autoencoders

License:          Apache License (>= 2.0)
URL:              https://cran.r-project.org/package=%{packname}
Source0:          %{url}&version=%{packver}#/%{packname}_%{packver}.tar.gz


BuildRequires:    R-devel >= 3.6.0
Requires:         R-core >= 3.6.0
BuildArch:        noarch
BuildRequires:    R-CRAN-data.table 
BuildRequires:    R-CRAN-mltools 
BuildRequires:    R-CRAN-reticulate 
BuildRequires:    R-CRAN-rappdirs 
BuildRequires:    R-CRAN-Rdpack 
Requires:         R-CRAN-data.table 
Requires:         R-CRAN-mltools 
Requires:         R-CRAN-reticulate 
Requires:         R-CRAN-rappdirs 
Requires:         R-CRAN-Rdpack 

%description
A tool for multiply imputing missing data using 'MIDAS', a deep learning
method based on denoising autoencoder neural networks (see Lall and
Robinson, 2022; <doi:10.1017/pan.2020.49>). This algorithm offers
significant accuracy and efficiency advantages over other multiple
imputation strategies, particularly when applied to large datasets with
complex features. Alongside interfacing with 'Python' to run the core
algorithm, this package contains functions for processing data before and
after model training, running imputation model diagnostics, generating
multiple completed datasets, and estimating regression models on these
datasets. For more information see Lall and Robinson (2023)
<doi:10.18637/jss.v107.i09>.

%prep
%setup -q -c -n %{packname}

# fix end of executable files
find -type f -executable -exec grep -Iq . {} \; -exec sed -i -e '$a\' {} \;
# prevent binary stripping
[ -d %{packname}/src ] && find %{packname}/src -type f -exec \
  sed -i 's@/usr/bin/strip@/usr/bin/true@g' {} \; || true
[ -d %{packname}/src ] && find %{packname}/src/Make* -type f -exec \
  sed -i 's@-g0@@g' {} \; || true
# don't allow local prefix in executable scripts
find -type f -executable -exec sed -Ei 's@#!( )*/usr/local/bin@#!/usr/bin@g' {} \;

%build

%install

mkdir -p %{buildroot}%{rlibdir}
%{_bindir}/R CMD INSTALL -l %{buildroot}%{rlibdir} %{packname}
test -d %{packname}/src && (cd %{packname}/src; rm -f *.o *.so)
rm -f %{buildroot}%{rlibdir}/R.css
# remove buildroot from installed files
find %{buildroot}%{rlibdir} -type f -exec sed -i "s@%{buildroot}@@g" {} \;

%files
%{rlibdir}/%{packname}
